#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include "p6stats.h"

typedef unsigned short WORD;
typedef unsigned long DWORD;


#define K 1024L
#define NUMERO (K*8)
DWORD OverHead0=0, OverHead1=0, Tiempo=0, TiempoOverHead=0;
DWORD m0;   // direcciones fsicas de 32 bits de nuestras matrices

/*
; Una instruccion "serializing" para lanzar antes de leer los contadores
cpuid                  macro
						db 0fh, 0a2h
					   endm
*/

void prueba(void)
  {
  /* esta primera vez es slo para que se cargue en la cach las rutinas*/
  TSCComenzar();
  ComenzarMonitor();
  TerminarMonitor();
  TiempoOverHead=TSCTerminar();

/*********************************************************************/
/* 					CALCULO DEL OVERHEAD */
/*********************************************************************/
	asm {
		db 0fh, 0a2h
		}
  TSCComenzar();
  ComenzarMonitor();
	/* Es conveniente introducir algunos NOP (40) para que el ROB se
	llene de NOP's y estas se ejecuten de 2 en 2 . Despues de ellas
	vendra el codigo que se quiere probar
	*/
	asm {
		NOP
		NOP
		NOP
		NOP

		NOP
		NOP
		NOP
		NOP

		NOP
		NOP
		NOP
		NOP

		NOP
		NOP
		NOP
		NOP
;16
		NOP
		NOP
		NOP
		NOP

		NOP
		NOP
		NOP
		NOP

		NOP
		NOP
		NOP
		NOP

		NOP
		NOP
		NOP
		NOP
; 32

		NOP
		NOP
		NOP
		NOP

		NOP
		NOP
		NOP
		NOP
 }
/*=== AQUI VENDRIA EL CODIGO DE PRUEBA  ===*/

  TerminarMonitor();
  TiempoOverHead=TSCTerminar();

  OverHead0=MPContador0;
  OverHead1=MPContador1;

/*********************************************************************/
/* AHORA EMPIEZA LA PRUEBA DE VERDAD*/
/*********************************************************************/
	asm {
		db 0fh, 0a2h
		}
  TSCComenzar();
  ComenzarMonitor();
	/* Es conveniente introducir algunos NOP (40) para que el ROB se
	llene de NOP's y estas se ejecuten de 2 en 2 . Despues de ellas
	vendra el codigo que se quiere probar
	*/
	asm {
		NOP
		NOP
		NOP
		NOP

		NOP
		NOP
		NOP
		NOP

		NOP
		NOP
		NOP
		NOP

		NOP
		NOP
		NOP
		NOP
;16
		NOP
		NOP
		NOP
		NOP

		NOP
		NOP
		NOP
		NOP

		NOP
		NOP
		NOP
		NOP

		NOP
		NOP
		NOP
		NOP
; 32

		NOP
		NOP
		NOP
		NOP

		NOP
		NOP
		NOP
		NOP
 }

/*=====================================================================*/
/**********  AQUI DEBE IR EL CODIGO PARA EVALUAR    ******************/
/*** sobre el que se medirn los eventos ***/
/*=====================================================================*/

/*=====================================================================*/
/* A CONTINUACIN SE PROPONEN VARIAS PRUEBAS. ELIMINAR LOS COMENTARIOS OPORTUNOS
   Y COMPILAR CADA UNA DE LAS PRUEBAS.
*/


/* PRUEBA 1: MEDIR EL CPI CON INSTRUCCIONES NOP */

	asm {
		nop
		nop
		nop
		nop

		nop
		nop
		nop
		nop
	 }

/* COMPROBAR EL EFECTO DE LAS DEPENDENCIAS DE DATOS. */

/*asm{	 mov ax,1
		 inc ax
		 inc ax
		 inc ax
		 inc ax
		 inc ax

		 mov bx,1
		 inc bx
		 inc bx
		 inc bx
		 inc bx
		 inc bx
}*/

/* PRUEBA 3: COMPROBAR LAS REGLAS DE EMPAREJAMIENTO EN EL PENTIUM. */

/*asm { 
		 mov ax,1
		 mov bx,1
		 mov cx,1
		 adc ax,ax ; 	Esta instruccin solo puede emitirse en la tubera U
				; Suma ax ms ax ms el bit carry (vale 0)
		 neg ax ; 	Esta instruccin no puede emparejarse con ninguna otra
				; Cambia de signo el registro ax
		 inc ax	; 	Incrementa en 1 el registro ax
		 inc bx

} */

/* PRUEBA 4: Es la traduccin de un bucle que hara un programador de bajo nivel
 que no tuviera en cuenta las dependencias ni los emparejamientos. No 
 obstante es mucho ms rpido que lo generado por la mayora de los compiladores.
 SE TRATA DE EJECUTAR ESTE BUCLE Y DESENROLLARLO Y OPTIMIZARLO PARA EVITAR 
 DEPENDENCIAS Y CUMPLIR LAS REGLAS DE EMPAREJAMIENTO. TAMBIEN PUEDEN HACERSE 
 PRUEBAS SOBRE LA PREDICCION DE LA BTB */

/* asm  {
arrayx	  dw 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10
		; 20 elementos de 16 bits (una palabra de Intel, o un entero int de BorlandC)

		 ; cabecera 5del cdigo de prueba (para inicializar los punteros).
		 ; Estas seis instrucciones se emparejan perfectamente en U y V.
		 ; Total duran tres ciclos
		 lea si, arrayx
		 nop
		 nop
		 nop
		 lea dx, [si+40]; 		dx apunta al fin del arrayx+1
		 nop
		 ; BUCLE BUCLE BUCLE
bucle:
		 mov ax,[si]
		 shl ax, 1 	; desplazamiento de 1 a izquierda, slo puede ir en tubera U
		 add ax, 1
		 mov [si],ax ; 	no modifica el bit de estado
		 add si, 2
		 cmp si, dx ; 	OJO! tiene dependencia con bit de estado
		 jne bucle ; 	slo puede ir en tubera V si quiero emparejar
				 ;accede a la BTB en fase PF

} */


/*=====================================================================*/
/**********  FIN DEL CODIGO PARA EVALUAR    ******************/
/*=====================================================================*/
  TerminarMonitor();
  Tiempo=TSCTerminar();
/*********************************************************************/
/* FIN DE LA PRUEBA 	*/
/*********************************************************************/

/* RESTAMOS EL TIEMPO DE OVERHEAD Y LOS EVENTOS DE OVERHEAD*/
  MPContador0-=OverHead0;
  MPContador1-=OverHead1;
  Tiempo-=TiempoOverHead;

  printf ("Duracin: %ld\nNumero de eventos contador 0: %lu\nNumero de eventos contador 1: %lu\n\n", Tiempo, MPContador0, MPContador1);

}

/*********************************************************************/
/*   main	*/
/*********************************************************************/
void main (void)
{
  int ev0,ev1;

  clrscr();

  printf("Dame evento 0 (en hexadec): ");
  scanf("%x",&ev0);
  fflush(stdin);   /* flush the input stream in case of bad input */
  printf("Dame evento 1 (en hexadec): ");
  scanf("%x",&ev1);
  fflush(stdin);   /* flush the input stream in case of bad input */

  SelecEvento (0, (BYTE)ev0, 0, N_EVENTOS);
  SelecEvento (1, (BYTE)ev1, 0, N_EVENTOS);

  printf ("\n-------Prueba de los contadores-------\n");

  disable();

  prueba();
  prueba();
  prueba();

  while(!kbhit());

  enable();

}
