.model large

.data
public C MPContador0
public C MPContador1

MPContador0            dd 0
MPContador1            dd 0

Cont0_64               dq 0
Cont1_64               dq 0
TSC64                  dq 0

rdmsr                  macro
                       db 0fh, 32h
                       endm

wrmsr                  macro
                       db 0fh, 30h
                       endm

rdtsc                  macro
                       db 0fh, 31h
                       endm

rdpmc                  macro
                       db 0fh, 33h
                       endm

.code
public C SelecEvento
public C ComenzarMonitor
public C TerminarMonitor
public C TSCComenzar
public C TSCTerminar

SelecEvento            proc C nc:byte, evento:byte, umask:byte, tipo:byte
                       .386
                       xor eax,eax
                       mov al,evento
                       mov ah,umask
                       xor ebx,ebx
                       mov bl,tipo
                       and bl,1   ;nos aseguramos de que EBX=0  1
                       shl ebx,18
                       or eax,00000000011000110000000000000000b  ;activar los dos contadores, monitorizar CPL=0..3
                       or eax,ebx
                       xor ecx,ecx
                       mov cl,nc
                       and cl,1   ;nos aseguramos de que ECX=0  1
                       add cx,186h  ;ECX=186h  187h, segun el valor de NC (numero de contador)
                       wrmsr
                       .286
                       ret
SelecEvento            endp

ComenzarMonitor        proc C
                       .386
                       xor ecx,ecx
		       rdpmc    ; Leemos contador 0 (ECX=0) y almacenamos
		       mov dword ptr Cont0_64,eax
		       mov dword ptr Cont0_64+4,edx
		       mov ecx,1
		       rdpmc    ; Leemos contador 1 (ECX=1) y almacenamos
		       mov dword ptr Cont1_64,eax
		       mov dword ptr Cont1_64+4,edx
		       .286
		       ret
ComenzarMonitor        endp

TerminarMonitor        proc C
		       .386
		       xor ecx,ecx
		       rdpmc    ; Leemos contador 0, calculamos diferencia y almacenamos
		       sub eax,dword ptr Cont0_64
		       sbb edx,dword ptr Cont0_64+4
		       mov MPContador0,eax
		       mov ecx,1
		       rdpmc    ; Leemos contador 1, calculamos diferencia y almacenamos
		       sub eax,dword ptr Cont1_64
		       sbb edx,dword ptr Cont1_64+4
		       mov MPContador1,eax
		       .286
		       ret
TerminarMonitor        endp

TSCComenzar            proc C
		       .386
		       rdtsc    ; Leemos Time Stamp Register y almacenamos
		       mov dword ptr TSC64,eax
		       mov dword ptr TSC64+4,edx
		       .286
		       ret
TSCComenzar            endp

TSCTerminar            proc C
		       .386
		       rdtsc    ; Leemos TSC, restamos y devolvemos los 32 bits menos significativos
		       sub eax,dword ptr TSC64
		       sbb edx,dword ptr TSC64+4
		       mov edx,eax
		       shr edx,16
		       .286
		       ret
TSCTerminar            endp

		       end
